﻿@using Jb.Framework.Common.Forms
@using Jb.Framework.Common.Forms.Validation;
@model Jb.Framework.Common.Forms.JbDropDown

@{
    if (Model.DefaultText == null && Model.Items != null && Model.Items.All(i => !string.IsNullOrEmpty(i.Value)))
    {
        Model.DefaultText = "";
    }
    var textBoxHtmlAttr = new Dictionary<string, object>();
    InputHelper.InputAccessible(Model, (VisibilityMode)ViewBag.VisibleMode, ref textBoxHtmlAttr);
    textBoxHtmlAttr.Add("class", "form-control");

    textBoxHtmlAttr.Add("placeholder", string.IsNullOrEmpty(Model.HelpText) ? string.Empty : Model.HelpText);
    textBoxHtmlAttr.Add("data-clientid", Model.Name);

    if (Model.IsConditional)
    {
        textBoxHtmlAttr.Add("data-conditional", true);
        textBoxHtmlAttr.Add("data-RelatedElementId", Model.RelatedElementId);
        textBoxHtmlAttr.Add("data-RelatedElementValue", Model.RelatedElementValue);
    }

    if (Model.Validations.Any(x => x.Type != ElementValidationType.None))
    {
        textBoxHtmlAttr.Add("data-val", "true");
    }
    if (Model.Validations.Any(x => x.Type == ElementValidationType.Required))
    {
        textBoxHtmlAttr.Add("data-val-Required", Model.Validations.First(x => x.Type == ElementValidationType.Required).Message);
    }

    if (Model.CurrentMode == AccessMode.ReadOnly)
    {
        textBoxHtmlAttr.Add("disabled", "disabled");
    }

    var titlevalue = Model.Title;

    // if field is required add star
    if (Model.Validations.Any(t => t.Type == ElementValidationType.Required))
    {
        titlevalue += " <span class='star'>*</span>";
    }
    var labelHtmlAttr = new Dictionary<string, object> { { "class", "Custom-label" }, { "data-value", titlevalue } };

    var width = "element_width-third";
    switch (Model.Width)
    {
        case ElementWidth.Half:
            {
                width = "element_width-half";
            }
            break;
        case ElementWidth.Full:
            {
                width = "element_width-full";
            }
            break;
    }
}

<div class="form-group JbFormControll JbDropDown @width" style="display: @(Model.VisibleMode != VisibilityMode.Both && Model.VisibleMode != (VisibilityMode)ViewBag.VisibleMode ? "none" : "block")">

    @for (var i = 0; i < Model.Validations.Count; i++)
    {
        //Custom model binder require full model name , i add Validations[i] at the end of string that mvc generate
        var hiddnModelBindername = "Validations[" + i + "].QVModelType";
        @Html.Hidden(hiddnModelBindername, Model.Validations[i].GetType())

        @Html.HiddenFor(x => x.Validations[i].IsChecked)
        @Html.HiddenFor(x => x.Validations[i].Type)
        @Html.HiddenFor(x => x.Validations[i].Message)
    }

    @Html.GenerateHiddenFields(Model)
    @Html.HiddenFor(m => m.JsonItems)
    @if (Model.CurrentMode == AccessMode.ReadOnly)
    {
        @Html.HiddenFor(m => m.Value)
    }
    @foreach (var accRole in Model.AccessRole)
    {
        @Html.HiddenFor(modelItem => accRole)
    }

    @Html.LabelFor(m => m.Value, Model.Title, new { @class = (Model.Validations.Any(t => t.Type == ElementValidationType.Required) || Model.IsRequired) ? "req" : "" })
    @if (!string.IsNullOrEmpty(Model.HelpText))
    {
        <a href="#" class="help" role="button" data-toggle="popover" data-trigger="focus" data-content="@Model.HelpText"></a>
    }
    @Html.DropDownListFor(model => model.Value, Model.Items!= null ? Model.Items.Select(item => new SelectListItem() { Value = item.Value, Text = item.Text }) : new List<SelectListItem>(), Model.DefaultText, htmlAttributes: textBoxHtmlAttr)
    @Html.ValidationMessageFor(model => model.Value)

</div>



